﻿using System;
using System.Collections.Generic;
using System.Text;
using MapApp.Model;

namespace MapApp.Ui.Controls
{
    public class ZoomHistory : LinkedList<MapLocation>
    {
        private LinkedListNode<MapLocation> _current;

        public MapLocation Current
        {
            get { return _current.Value; }
        }

        #region Constructors
        public ZoomHistory()
            : base()
        {
            _current = First; // or last, same thing
        }

        #endregion Constructors

        #region Properties

        #endregion Properties

        #region Methods
        public MapLocation Peek()
        {
            return Current;
        }

        public MapLocation Pop()
        {
            if (_current.Previous != null)
            {
                _current = _current.Previous;
            }
            return _current.Value;
        }

        public MapLocation UnPop()
        {
            LinkedListNode<MapLocation> result = _current;
            if (_current.Next != null)
            {
                _current = _current.Next;
            }
            return _current.Value;
        }

        public void Push(MapLocation loc)
        {
            if (_current == null)
            {
                _current = AddFirst(loc);
            }
            else
            {
                _current = AddAfter(_current, loc);
            }
        }

        #endregion Methods

    }
}
